package silmarengine.contexts.beingmovement.domain.functions

import silmarengine.contexts.beingmovement.domain.model.*
import silmarengine.objectpools.floatPointPool
import silmarengine.objectpools.bmPixelDistancePool as pixelDistancePool
import silmarengine.objectpools.bmPixelPointPool as pixelPointPool
import silmarengine.util.sleepThread
import java.awt.geom.Point2D
import java.util.*
import kotlin.math.abs
import kotlin.math.floor
import kotlin.math.roundToInt

/**
 * The result of a call to moveTowardsGoal (which is specified nearby).
 */
class MoveTowardsGoalResult(
    /**
     * Whether the goal could not be reached due to running into something impassible.
     */
    val impass: Boolean = false,
    /**
     * Whether the goal could not be reached due to running out of movement points.
     */
    val notEnoughMovementPoints: Boolean = false,
    /**
     * How many movement points were left over at the end of the movement.
     */
    val movementPointsLeft: Float = 0f
)

/**
 * Describes an interest in listening to events generated by the moveTowardsGoal method
 * below.
 */
interface MoveTowardsGoalListener {
    /**
     * Informs this listener that the entity has been moved onto a
     * different tile, the one given.
     *
     * @return      Whether the overall movement should continue.
     */
    fun onMovedOntoNewTile(tile: Tile): Boolean

    /**
     * Informs this listener that the entity has arrived at the given
     * terrain feature.
     *
     * @return      Whether the overall movement should continue.
     */
    fun onAtTerrain(terrain: Terrain): Boolean

    /**
     * Returns whether the entity is capable of continuing its movement toward the goal
     * after the current step taken.
     *
     * @param oldLocation   Where the entity was before the current step.
     */
    fun getShouldContinue(oldLocation: PixelPoint): Boolean
}

/**
 * How many pixels an entity moves per step in doMoveTowardsGoal().
 */
const val pixelsPerMove = 4

/**
 * Moves this being towards the given goal however far the given
 * amount of movement points will take it.
 *
 * NOTE: The points on the line on which the movement is taking place
 * must be the same ones tested by Area.isLinePassible, since that routine
 * is called to give the ok for this one to be called.  This means that
 * the two routines must be kept in sync.
 *
 * @param listener          Listens for events occurring in this method.
 */
inline fun Being.moveTowardsGoal(
    goal: PixelPoint, movementPoints: Float, listener: MoveTowardsGoalListener?,
    shouldSeekDetours: Boolean,
    getUnitVector: (from: PixelPoint, to: PixelPoint, use: Point2D.Float) -> Point2D.Float,
    getDistance: (from: PixelPoint, to: PixelPoint, use: PixelDistance) -> PixelDistance
): MoveTowardsGoalResult {
    // if the entity is already at the goal, there is nothing to do
    if (goal == location) return MoveTowardsGoalResult(
        movementPointsLeft = movementPoints)

    // determine the delta vector to be travelled during each step
    // from the entity's current location to the goal
    val location = pixelPointPool.supply()
    location.set(this.location)
    val direction = getUnitVector(location, goal, floatPointPool.supply())
    direction.x *= pixelsPerMove.toFloat()
    direction.y *= pixelsPerMove.toFloat()

    // determine how many moves it will take to get to the goal
    val distanceToGoal = getDistance(location, goal, pixelDistancePool.supply())
    val numMoves =
        getDistance(location, goal, distanceToGoal).distance.toFloat() / pixelsPerMove
    val tileFractionPerMove = pixelsPerMove.toFloat() / tileWidth
    pixelDistancePool.reclaim(distanceToGoal)

    // determine the initial terrains the entity is on
    val terrainsOn = ArrayList(area.getTerrainsInRectangle(location, size))

    // for each step along the line to the goal
    val current = floatPointPool.supply()
    current.setLocation(location.x.toFloat(), location.y.toFloat())
    val roundedCurrent = pixelPointPool.supply()
    val testRectSize = size
    val oldLocation = pixelPointPool.supply()
    oldLocation.set(location)
    val save = floatPointPool.supply()
    val numIterations = (floor(
        numMoves.toDouble()) + if (numMoves != numMoves.toInt().toFloat()) 1 else 0).toInt()
    var movementPointsUsed = 0f
    var lastTime = System.currentTimeMillis()
    var impass = false
    var notEnoughMovementPoints = false
    for (i in 0 until numIterations) {
        // calculate where the next step will lead; the final step will likely be
        // fractional, to get this entity to the goal location (if no
        // obstacle-avoidance movement (see below) has taken place during this loop)
        save.setLocation(current)
        val fraction = numMoves - i
        if (fraction > 0.0 && fraction < 1.0) {
            current.x += direction.x * fraction
            current.y += direction.y * fraction
        }
        else {
            current.x += direction.x
            current.y += direction.y
        }

        // if this step's location is impassible
        roundedCurrent.set(current.x.roundToInt(), current.y.roundToInt())
        var fractionOfStepTaken = 1f
        if (!area.isRectanglePassible(roundedCurrent, testRectSize, bmMovementType, true,
                this, null, false).passible) {
            // if the entity is a player, and we aren't on the last, fractional move
            var canContinue = false
            if (shouldSeekDetours && numMoves - i >= 1) {
                // we are going to try to find an alternative movement that might lead
                // to getting around the impassible obstacle, so that the player doesn't
                // get stuck on corners, etc.; for monsters, correct paths are assumed
                // to be calculated such this isn't needed

                // if the travel direction has a not-insignificant y-delta, or the same
                // step without the x-delta is passible
                current.setLocation(save)
                current.y += direction.y
                roundedCurrent.set(current.x.roundToInt(), current.y.roundToInt())
                if (abs(direction.y) >= 0.1 && area.isRectanglePassible(roundedCurrent,
                        testRectSize, bmMovementType, true, this, null, false).passible) {
                    // the step without the x-delta will be taken
                    canContinue = true
                    fractionOfStepTaken = direction.y / (direction.x + direction.y)
                }
                else {
                    // if the travel direction has a not-insignificant x-delta, and the
                    // same step without the y-delta is passible
                    current.setLocation(save)
                    current.x += direction.x
                    roundedCurrent.set(current.x.roundToInt(), current.y.roundToInt())
                    if (abs(direction.x) >= 0.1 && area.isRectanglePassible(
                            roundedCurrent, testRectSize, bmMovementType, true, this,
                            null, false).passible) {
                        // the step without the y-delta will be taken
                        canContinue = true
                        fractionOfStepTaken = direction.x / (direction.x + direction.y)
                    }
                }
            }

            // if the above didn't produce a workable alternative movement
            if (!canContinue) {
                // the movement stops just before here
                impass = true
                break
            }
        }

        // determine whether or not this step involves moving onto a different tile
        val tileChanged =
            roundedCurrent.x / tileWidth != location.x / tileWidth || roundedCurrent.y / tileHeight != location.y / tileHeight

        // move this entity up to this point
        location.set(roundedCurrent.x, roundedCurrent.y)
        area.moveEntity(this, location)

        checkForMovementSound()

        // if this entity did move onto a different tile
        var shouldStop = false
        var lastMove = false
        if (tileChanged) {
            // inform our listener; if it says to stop, stop
            lastMove = i.toFloat() == numMoves - 1
            if (listener != null) {
                val tile = area.getTile(location)
                if (!listener.onMovedOntoNewTile(tile) && !lastMove) shouldStop = true
            }
        }

        // incur the movement cost of this step
        val movementCost = area.getTile(location).movementCost
        movementPointsUsed += movementCost * tileFractionPerMove * fractionOfStepTaken

        // if this entity is now out of movement points
        if (movementPointsUsed >= movementPoints && !lastMove) {
            notEnoughMovementPoints = true
            shouldStop = true
        }

        // for each terrain within the entity's new current rectangle
        val terrains = area.getTerrainsInRectangle(location, size)
        terrains.forEach {
            shouldStop = checkForArrivalToTerrain(it, terrainsOn, listener, shouldStop)
        }

        // remove from our terrains-on list those terrains which aren't in
        // our list of terrains at the new current location, as the entity
        // must have left them behind
        terrainsOn.removeIf { !terrains.contains(it) }

        // ask our listener if its ok to proceed with this movement loop
        if (listener != null && !listener.getShouldContinue(oldLocation)) shouldStop =
            true
        oldLocation.set(location)

        // if the user can see this step of this movement, check to slow down the
        // display of this step
        if (isVisibleToUser()) lastTime = checkToSlowDownMovement(lastTime)

        // if the code above has determined this movement must now end, then end it
        if (shouldStop) break
    }

    pixelPointPool.reclaim(location)
    pixelPointPool.reclaim(roundedCurrent)
    pixelPointPool.reclaim(oldLocation)
    floatPointPool.reclaim(direction)
    floatPointPool.reclaim(current)
    floatPointPool.reclaim(save)

    val movementPointsLeft = movementPoints - movementPointsUsed
    return MoveTowardsGoalResult(impass, notEnoughMovementPoints, movementPointsLeft)
}

/**
 * @return  The updated value of shouldStop_
 */
fun Entity.checkForArrivalToTerrain(
    terrain: Terrain, terrainsOn: ArrayList<Terrain>, listener: MoveTowardsGoalListener?,
    shouldStop_: Boolean
): Boolean {
    // if this terrain isn't already in the terrains-on list
    var shouldStop = shouldStop_
    if (!terrainsOn.contains(terrain)) {
        // add it
        terrainsOn.add(terrain)

        // if the entity is a being
        if (this is Being) {
            // inform the terrain of this entity's arrival; if the terrain
            // says this movement should stop, stop
            if (terrain.onBeingArrival(this)) shouldStop = true
        }

        // inform our listener; if it says to stop, stop
        if (listener?.onAtTerrain(terrain) == false) shouldStop = true
    }

    return shouldStop
}

/**
 * @return  The updated value of lastTime_
 */
fun Being.checkToSlowDownMovement(lastTime_: Long): Long {
    // time how long this movement step took
    var lastTime = lastTime_
    val newTime = System.currentTimeMillis()
    val delta = newTime - lastTime
    lastTime = newTime

    // if the movement step didn't take up at least a certain amount of time
    val minimumStepTime = if (shouldMovementBeAccelerated) 15 else 25
    if (delta < minimumStepTime) {
        // sleep for the rest of that time, so that movement isn't too fast on speedy systems
        sleepThread(minimumStepTime - delta)
    }

    return lastTime
}